<app-loading *ngIf="isLoadingPage"></app-loading>
<div>
  <form nz-form [formGroup]='form'>

    <div nz-row [nzGutter]='[30,30]'>
      <div nz-col [nzLg]='12' [nzXs]='12' class='select__employee'>
        <employee-data-picker
          (ngModelChange)="changeEmp($event)"
          [mbCanText]='true'
          formControlName='employee'
          mbLabelText="{{'partnership.pns-contract.label.chooseEmployee' | translate}} <span class='label__required'>*</span>"
          [mbType]="isSubmitted && form.controls['employee'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['employee'].errors !== null"
          [mbErrors]="form.controls['employee'].errors"
          [scope]="scope"
          [functionCode]="functionCode"
          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'partnership.pns-contract.validate.required' | translate: {'param': 'partnership.pns-contract.label.employee' | translate }}]"
        ></employee-data-picker>
      </div>
      <div nz-col [nzLg]='12' [nzXs]='12' class='select__employee'>
        <mb-input-text formControlName='personalEmail'
                       [mbType]="isSubmitted && form.controls['personalEmail'].errors ? 'error' : 'default'"
                       [mbShowError]="isSubmitted && form.controls['personalEmail'].errors != null"
                       [mbErrors]="form.controls['personalEmail'].errors"
                       [mbErrorDefs]="[{ errorName: 'email', errorDescription: 'partnership.validate.format' | translate: {'param': 'partnership.pns-contract.label.personalEmail' | translate }}]"
                       mbLabelText="{{'partnership.pns-contract.label.personalEmail' | translate}} "
                       mbPlaceholderText="{{'partnership.pns-contract.label.personalEmail' | translate}}">
        </mb-input-text>
      </div>
    </div>
    <div nz-row [nzGutter]='[30,30]'>
      <div nz-col [nzXs]='12' [nzLg]='12'>
        <mb-date-picker
          (ngModelChange)="changeLeaveDate($event)"
          [mbType]="form.controls['leaveDate'].errors ? 'error' : 'default'"
          [mbShowError]="form.controls['leaveDate'].errors !== null"
          [mbErrors]="form.controls['leaveDate'].errors"
          mbPlaceholderText="{{'partnership.pns-contract.label.leaveDate' | translate}}"
          mbLabelText="{{'partnership.pns-contract.label.leaveDate' | translate}}"
          formControlName='leaveDate'></mb-date-picker>
      </div>
      <div nz-col [nzLg]='12' [nzXs]='12'>
        <mb-input-text
          (ngModelChange)="changeNotifyDays($event)"
          [mbSuffixTemplate]="'Ngày'"
          appNumberic
          [num]="3"
          mbLabelText="{{'partnership.pns-contract.label.notifyDay' | translate}} "
          formControlName='notifyDay'
        ></mb-input-text>
      </div>

      <div nz-col [nzXs]='12' [nzLg]='12'>
        <mb-date-picker
          (ngModelChange)="changeLastWorkingDate($event)"
          [mbType]="(form.controls['lastWorkingDate'].errors || form.errors?.rangeDateError) ? 'error' : 'default'"
          [mbShowError]="(form.controls['lastWorkingDate'].errors || form.errors?.rangeDateError) !== null"
          [mbErrors]="form.errors?.rangeDateError ? form.errors : form.controls['lastWorkingDate'].errors"
          [mbErrorDefs]="[{ errorName: 'rangeDateError', errorDescription: 'partnership.pns-contract.validate.rangeDate.pareDateMore' | translate:{'fromDate': 'partnership.pns-contract.label.leaveDate' | translate, 'toDate': 'partnership.pns-contract.label.lastWorkingDate' | translate}}]"
          mbPlaceholderText="{{'partnership.pns-contract.label.lastWorkingDate' | translate}}"
          mbLabelText="{{'partnership.pns-contract.label.lastWorkingDate' | translate}}"
          formControlName='lastWorkingDate'></mb-date-picker>
      </div>


      <div nz-col [nzLg]='12' [nzXs]='12'>
        <mb-select [mbDataSelects]='listRetireReason'
                   mbKeyLabel='label'
                   mbKeyValue='value'
                   mbLabelText="{{'partnership.pns-contract.label.retireReason' | translate}} <span class='label__required'>*</span>"
                   mbPlaceholder="{{'partnership.pns-contract.label.retireReason' | translate}}"
                   [mbType]="isSubmitted && form.controls['reasonCode'].errors ? 'error' : 'default'"
                   [mbShowError]="isSubmitted && form.controls['reasonCode'].errors !== null"
                   [mbErrors]="form.controls['reasonCode'].errors"
                   [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'partnership.pns-contract.validate.required' | translate: {'param': 'partnership.pns-contract.label.retireReason' | translate }}]"
                   formControlName='reasonCode'></mb-select>
      </div>

      <div nz-col [nzLg]='24' [nzXs]='24'>
        <mb-input-text
          [mbIsTextAre]='true' [mbMaxLength]='2000'
          mbLabelText="{{'partnership.pns-contract.label.retireReasonDetail' | translate}} "
          mbPlaceholderText="{{'partnership.pns-contract.label.retireReasonDetail' | translate}}"
          formControlName='retireReason'
        ></mb-input-text>
      </div>
    </div>

    <div nz-row class='label__divider--wrap'>
      <div nz-col [nzXs]='24' [nzLg]='24' class='input__group'>
        <label
          class='label__divider'>{{'partnership.pns-contract.contractLiquidationSuggest.label.liquidationDocumentLabel' | translate}}</label>
      </div>
    </div>
    <nz-divider class='hrTag'></nz-divider>

    <div nz-row [nzGutter]='[30,30]'>
      <!-- QUẢN LÝ TRỰC TIẾP -->
      <ng-container formArrayName='listFileDocument'>
        <nz-table nz-col nzXs='24' nzLg='24' [nzData]='listFileDocument?.controls' nzSize='small'
                  [nzShowPagination]='false' [nzPageSize]='listFileDocument?.controls.length' nzTableLayout="fixed">
          <thead>
          <tr>
            <th scope="col" nzWidth='40%'>{{'partnership.pns-contract.label.documentType' | translate}}</th>
            <th scope="col" nzWidth='50%'>{{'partnership.pns-contract.label.attachFile' | translate}}</th>
            <th scope="col" nzWidth='10%'></th>
          </tr>
          </thead>
          <tbody>
          <tr *ngFor='let data of listFileDocument?.controls; let i = index; let first = first' [formGroupName]='i'>
            <td>
              <mb-select [mbDataSelects]='listDocumentType'
                         mbKeyLabel='label'
                         mbKeyValue='value'
                         [mbDisable]='data.get("canNotDelete").value'
                         [mbType]="isSubmitted && data.controls['type']?.errors ? 'error' : 'default'"
                         [mbShowError]="isSubmitted && data.controls['type']?.errors != null"
                         [mbErrors]="data.controls['type']?.errors"
                         [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'partnership.pns-contract.validate.required' | translate: {'param': 'partnership.pns-contract.label.documentType' | translate }}]"
                         mbPlaceholder="{{'partnership.pns-contract.label.documentType' | translate}}"
                         formControlName='type'></mb-select>
            </td>
            <td>
              <mb-upload-file
                (fileListChange)='onFileListChange($event, data)'
                [fileList]="data.get('listDocuments').value"
                mbTypeUpload='upload'
                [mbTypeFileAvailable]="['jpg', 'png', 'pdf', 'doc', 'docx', 'xls', 'xlsx', 'tif', 'gif']"
                [mbMultiple]='true'
                (docIdsDeleteChange)='removeFile($event, data)'
                [mbServiceName]='serviceName'
              ></mb-upload-file>
            </td>
            <td class='align-center'>
              <mb-button
                (click)='addFileDocument()'
                mbButtonIconType='AWESOME' mbPrefixIcon='far fa-plus-circle'
                mbButtonSize='SMALL'
                mbButtonTextColor='#141ED2' mbButtonType='NO_BORDER'
              ></mb-button>

              <mb-button
                (click)='removeFileDocument(i)'
                mbButtonIconType='AWESOME' mbPrefixIcon='far fa-trash-alt'
                mbButtonSize='SMALL' [mbIsDisable]='first || data.get("canNotDelete").value'
                mbButtonTextColor='#FA0B0B' mbButtonType='NO_BORDER'
              ></mb-button>
            </td>
          </tr>
          </tbody>
        </nz-table>
      </ng-container>
      <!-- END QUẢN LÝ TRỰC TIẾP -->
    </div>
    <div nz-row class='label__divider--wrap'>
      <div nz-col [nzXs]='24' [nzLg]='24' class='input__group'>
        <label
          class='label__divider'>{{'partnership.pns-contract.contractLiquidationSuggest.label.consultationInfoLabel' | translate}}</label>
      </div>
    </div>
    <nz-divider class='hrTag'></nz-divider>
    <div nz-row [nzGutter]='[30,30]'>
      <ng-container formArrayName='listConsultationInfo'>
        <nz-table nz-col nzXs='24' nzLg='24' [nzData]='listConsultationInfo?.controls' nzSize='small'
                  [nzShowPagination]='false' [nzPageSize]='listConsultationInfo?.controls.length' nzTableLayout="fixed">
          <thead>
          <tr>
            <th scope="col" class='align-center' nzWidth='15%'
                *ngIf='contractLiquidationEdit?.status === 1 && mode === Mode.EDIT && objFunction?.approve'>
              {{'partnership.pns-contract.label.consultationsRequest' | translate}}
            </th>
            <th scope="col" nzWidth='28%'>{{'partnership.pns-contract.label.informationType' | translate}}</th>
            <th scope="col" class='align-center' nzWidth='22%' *ngIf='mode === Mode.EDIT'>
              {{'partnership.pns-contract.label.status' | translate}}
            </th>
            <th scope="col" nzWidth='30%' *ngIf='mode === Mode.EDIT'>{{'partnership.pns-contract.label.informationDetail' | translate}}</th>
            <th scope="col" nzWidth='7%'></th>
          </tr>
          </thead>
          <tbody>
          <tr *ngFor='let data of listConsultationInfo?.controls; let i = index; let first = first' [formGroupName]='i'>
            <td class='align-center'
                *ngIf='contractLiquidationEdit?.status === 1 && mode === Mode.EDIT && objFunction?.approve'>
              <label class='consultationInfo__checkbox' nz-checkbox
                     (nzCheckedChange)='checkConsultationsRequest($event, i)'>
              </label>
            </td>
            <td>
              <mb-select [mbDataSelects]='listConsultationInfoType'
                         mbKeyLabel='label'
                         mbKeyValue='value'
                         [mbDisable]='data.get("canNotDelete").value'
                         [mbType]="isSubmitted && data.controls['type']?.errors ? 'error' : 'default'"
                         [mbShowError]="isSubmitted && data.controls['type']?.errors != null"
                         [mbErrors]="data.controls['type']?.errors"
                         [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'partnership.pns-contract.validate.required' | translate: {'param': 'partnership.pns-contract.label.informationType' | translate }}]"
                         mbPlaceholder="{{'partnership.pns-contract.label.informationType' | translate}}"
                         formControlName='type'></mb-select>
            </td>
            <td class='align-center' *ngIf='mode === Mode.EDIT'>
              <ng-container *ngTemplateOutlet='status;context:data'></ng-container>
            </td>
            <td *ngIf='mode === Mode.EDIT'>
              {{ data.controls['note']?.value }}
            </td>
            <td class='align-center'>
              <mb-button
                (click)='addConsultationInfo()'
                mbButtonIconType='AWESOME' mbPrefixIcon='far fa-plus-circle'
                mbButtonSize='SMALL'
                mbButtonTextColor='#141ED2' mbButtonType='NO_BORDER'
              ></mb-button>

              <mb-button
                (click)='removeConsultationInfo(i)'
                mbButtonIconType='AWESOME' mbPrefixIcon='far fa-trash-alt'
                mbButtonSize='SMALL' [mbIsDisable]='first || data.get("canNotDelete").value'
                mbButtonTextColor='#FA0B0B' mbButtonType='NO_BORDER'
              ></mb-button>
            </td>
          </tr>
          </tbody>
        </nz-table>
      </ng-container>
    </div>
    <div nz-row class='btnGroup'>
      <div nz-col [nzLg]='24' [nzXs]='24' *ngIf='isConsultationsRequest'>
        <mb-input-text
          [mbIsTextAre]='true' [mbMaxLength]='2000'
          mbLabelText="{{'partnership.pns-contract.label.reasonReject' | translate}} "
          mbPlaceholderText="{{'partnership.pns-contract.label.reasonReject' | translate}}"
          formControlName='rejectReason'
        ></mb-input-text>
      </div>
    </div>

    <!--Button-->
    <div nz-row [nzGutter]='[30,0]' class='btnGroup'>
      <div nz-col [nzXs]='24' [nzLg]='24' [ngStyle]="{'text-align': 'right'}">
        <button
          nz-button
          nzType='default'
          (click)='closeModalAdd()'
        >{{'partnership.dependentRegisters.cancel' | translate}}</button>
        <mb-button
          (click)='onApproval()'
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY'
          mbButtonText="{{'partnership.pns-contract.label.approval' | translate}}"
          *ngIf='contractLiquidationEdit?.status === 1 && mode === Mode.EDIT && objFunction?.approve && !isConsultationsRequest'
        ></mb-button>
        <mb-button
          (click)='approveReject()'
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY'
          mbButtonText="{{'partnership.pns-contract.label.consultationsRequest' | translate}}"
          *ngIf='contractLiquidationEdit?.status === 1 && mode === Mode.EDIT && objFunction?.approve && isConsultationsRequest'
        ></mb-button>
        <mb-button
          *ngIf="!isCompleteProfile; else: complete"
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY'
          (click)='onSave()'
          mbButtonText="{{'partnership.pns-contract.label.save' | translate}}"
        ></mb-button>
        <ng-template #complete>
          <mb-button
            mbButtonSize='SMALL'
            mbButtonAvailableStyle='PRIMARY'
            (click)='onCompleteProfile()'
            mbButtonText="{{'partnership.pns-contract.label.completeProfile' | translate}}"
          ></mb-button>
        </ng-template>

      </div>
    </div>
    <!--End: Button-->

  </form>
</div>


<!-- Trạng thái -->
<ng-template #statusTmpl let-isCheck='controls["isCheck"].value'>
  <ng-container *ngFor='let item of constant.CONTRACT_LIQUIDATION_APPROVAL_STATUS'>
    <nz-tag [nzColor]='item.bgColor' [ngStyle]="{'color': item.color}"
            *ngIf='isCheck === item.value'>{{item.label | translate}}</nz-tag>
  </ng-container>
</ng-template>
<!--End: Trạng thái-->
